//
// Esempio di utilizzo delle eccezioni
//

#include <iostream.h>

// Tipo enumerato per rappresentare alcune condizioni di errore
enum Errors {DIVIDEBYZERO, STRANGE};


class MyShort {
private:
  short v;

public:
  // Classe per rappresentare una eccezione di tipo Range
  class RangeExcp {
  public:
    char op;

    RangeExcp(char c)
      { op = c; }
  };


  MyShort(long l = 0) throw (RangeExcp);
  friend MyShort operator/ (MyShort a, MyShort b) throw (Errors);
  friend MyShort operator* (MyShort a, MyShort b) throw (RangeExcp);
  friend MyShort operator+ (MyShort a, MyShort b) throw (RangeExcp);
  friend MyShort operator- (MyShort a, MyShort b) throw (Errors);
  friend MyShort operator- (MyShort a) throw (int);

  friend istream& operator>> (istream& ci, MyShort& m) throw (RangeExcp);
  friend ostream& operator<< (ostream& co, const MyShort& m);
};
